from pypsrp.powershell import PowerShell, RunspacePool
from pypsrp.wsman import WSMan
from pypsrp.shell import Process, SignalCode, WinRS
from pypsrp.client import Client
import os

# see : https://pypi.org/project/pypsrp/
# see : https://snyk.io/advisor/python/pypsrp/functions/pypsrp.powershell.PowerShell

def openConn(hostaddr,username,authentication):
    conn = WSMan(hostaddr, username=username, password=authentication, ssl=False, locale='en-US', data_locale='en-US')
    rs = RunspacePool(conn)
    rs.open()
    return conn

def run(conn,cmd):
    data = dict()
    possible_file = os.getcwd()+'/scripts/'+cmd.strip()
    if( os.path.isfile(possible_file) ):
        file = open(possible_file, 'r')
        script = '\n'.join([str(s) for s in file.readlines()])
        file.close()
        with conn, RunspacePool(conn) as pool:
            ps = PowerShell(pool)
            ps.add_script(script)
            ps.invoke(["string", "TEST"])
            data['stdout'] = '\n'.join([str(s) for s in ps.output])
            data['stderr'] = '\n'.join([str(s) for s in ps.streams.error])
            data['debug'] = '\n'.join([str(s) for s in ps.streams.debug])
            print(data)
            return data
    else:
        client = Client("")
        client.wsman = conn
        stdout, streams, had_errors = client.execute_ps(cmd)
        data['stdout'] = stdout
        data['stderr'] = '\n'.join([str(s) for s in streams.error])
        data['debug'] = '\n'.join([str(s) for s in streams.debug])
        #data['verbose'] = '\n'.join([str(s) for s in streams.verbose])
        #data['retval'] = rc
        return data
